local credits = {}
credits.startx = 20
credits.starty = 50
credits.margin = 20

function credits.init()
    credits.text = {}
    for line in love.filesystem.lines("credits.txt") do
        local remainingLine = line
        while defaultFont:getWidth(remainingLine) + credits.margin * 2> love.graphics.getWidth()  do
            local percentageWeNeedToCut = love.graphics.getWidth() / defaultFont:getWidth(remainingLine)
            local currentLine = string.sub(remainingLine, 1, math.floor(remainingLine:len()  * percentageWeNeedToCut))
            remainingLine = string.sub(remainingLine, math.ceil(remainingLine:len()  * percentageWeNeedToCut))
            credits.text[#credits.text + 1] = currentLine
        end
        credits.text[#credits.text + 1] = remainingLine

    end
    credits.scrollpos = 1
end

function credits.render()
    love.graphics.clear(0, 0, 0, 0, 1)
    love.graphics.setColor(1, 1, 1, 1)
    local currentY = credits.margin
    for i = credits.scrollpos, #credits.text do
        line = credits.text[i]
        if line then
            love.graphics.print(line, credits.margin, currentY)
            currentY = currentY + 20
        else
            return
        end
    end
end

function credits.scroll(amount)
    credits.scrollpos = credits.scrollpos + amount
    credits.scrollpos = utils.clamp(credits.scrollpos, 1, #credits.text)
end

return credits
