local ui = require("ui")

local rougelike = require("rougelike")
local mainmenu = require("mainmenu")
local leveldone = {}
function leveldone.init(isWin)
    local stage = ui.newStage()

    if isWin then
        local header = ui.newLabel("You win!")
        local explanation = ui.newLabel("You reached the target.")
        local continueBtn = ui.newButton("Continue to next Level")

        local container = ui.newPanel(200, 200, 500, 500, 10, 20)
        container.bgcolor = {r=0.3,g=0.3,b=0.3,a=0.8}
        container:addCild(header)
        container:addCild(explanation)
        container:addCild(continueBtn)

        continueBtn.onclick = function(button)

            gamestate = GAMESTATES.default
            rougelike.generateLevel(currentRun)

        end

        continueBtn:select()

        container:layout()
        container.x = love.graphics.getWidth( ) / 2 - (container.width / 2)
        container:layout()

        stage:addRootElement(container)
    else
        local header = ui.newLabel("You loose!")

        local timeTaken = currentRun.endtime - currentRun.start
        local prettyTime = utils.prettyTime(timeTaken)

        local explanation = ui.newLabel( "You cleared " ..
                                            (currentRun.level - 1) ..
                                            " levels in " .. prettyTime)
        local seedLabel = ui.newLabel(
                                      'Press "ctrl+c" to copy your stats and the seed')

        local mainMenuBtn = ui.newButton("Back to main menu")

        mainMenuBtn.onclick = function(button)

            gamestate = GAMESTATES.menu
            mainmenu.init()

        end

        local container = ui.newPanel(200, 200, 500, 500, 10, 20)
        container.bgcolor = {r=0.3,g=0.3,b=0.3,a=0.8}
        container:addCild(header)
        container:addCild(explanation)
        container:addCild(seedLabel)
        container:addCild(mainMenuBtn)

        mainMenuBtn:select()

        container:pack()
        container.x = love.graphics.getWidth( ) / 2 - (container.width / 2)

        stage:addRootElement(container)

    end

    activeStage = stage

end

return leveldone
