ui = require("ui")
rougelike = require("rougelike")
local mainmenu = {}

mainmenu.elements = {}

function mainmenu.init()
    local stage = ui.newStage()
    local label = ui.newLabel(
                      "Try to get to the green target zone.\nDon't hit the walls.\nUse the Arrow keys or the left stick and right trigger to steer")
    local startGame = ui.newButton("Start game")
    local seedlabel = ui.newLabel("Seed:")

    local credits = ui.newButton("Credits")
    local textField = ui.newTextField(150, tostring(os.time()))
    function textField:textinput(t)
        if t >= "0" and t <= "9" and string.len(self.text) < 10 then
            self.text = self.text .. t
        end
    end

    local container = ui.newPanel(200, 200, 500, 500, 10, 20)
    container.bgcolor = {r = 0, g = 0, b = 0, a = 1}
    local seedcontainer = ui.newPanel(200, 200, 500, 30, 10, 20)
    seedcontainer.layoutManager = ui.linearHorizontalLayoutManager
    seedcontainer:addCild(seedlabel)
    seedcontainer:addCild(textField)
    container:addCild(label)
    container:addCild(startGame)
    container:addCild(credits)
    container:addCild(seedcontainer)

    startGame.onclick = function(button)
        GAMESTATES.menu.inputseed = textField.text
        if button == 1 then startRougelikeGame() end

    end

    credits.onclick = function(button) if button == 1 then showCredits() end end

    startGame:select()

    container:pack()
    container.x = love.graphics.getWidth() / 2 - (container.width / 2)
    stage:addRootElement(container)
    activeStage = stage

end

return mainmenu
