local ui = require("ui")

local rougelike = require("rougelike")
local mainmenu = require("mainmenu")
local upgrade = {}
function upgrade.init()
    local stage = ui.newStage()

    local header = ui.newLabel(
                       "You earned an upgrade. Please select which part to upgrade ")
    local thrustersBtn = ui.newButton("Thrusters (faster turning)")

    local fuelBtn = ui.newButton("Fuel tanks(more fuel)")

    local reverseBtn = ui.newButton("Reverse thrusters")
    local currentLevelsLabel = ui.newLabel(
                                   'Current Levels:\nthrusters: (' ..
                                       tostring(currentRun.upgrades.thrusters) ..
                                       '/' ..
                                       tostring(rougelike.maxUpgrades.thrusters) ..
                                       '). fuel: (' ..
                                       tostring(currentRun.upgrades.fuel) .. '/' ..
                                       tostring(rougelike.maxUpgrades.fuel) ..
                                       ')' .. ' reverse thrusters: (' ..
                                       tostring(currentRun.upgrades.reverse) ..
                                       '/' ..
                                       tostring(rougelike.maxUpgrades.reverse) ..
                                       ')')
    local container = ui.newPanel(200, 200, 500, 500, 10, 20)
    container.bgcolor = {r = 0.3, g = 0.3, b = 0.3, a = 0.8}
    container:addCild(header)
    container:addCild(thrustersBtn)
    container:addCild(fuelBtn)
    container:addCild(reverseBtn)
    container:addCild(currentLevelsLabel)

    local function tryUpgrade(part)
        if rougelike.upgrade(currentRun, part) then
            gamestate = GAMESTATES.default
            rougelike.generateLevel(currentRun)
        end
    end

    thrustersBtn.onclick = function(button) tryUpgrade("thrusters") end

    fuelBtn.onclick = function(btn) tryUpgrade("fuel") end

    reverseBtn.onclick = function(btn) tryUpgrade("reverse") end

    container:pack()
    container.x = love.graphics.getWidth() / 2 - (container.width / 2)
    stage:addRootElement(container)

    activeStage = stage

end

return upgrade
