utils = {}
hasbit,bit = pcall(require,"bit")
if not hasbit then
    hasbit,bit =  pcall(require,"bit32")
end
function utils.tostring(arg, alreadyEncountered)
    if type(arg) ~= "table" then return tostring(arg) end

    if (alreadyEncountered[arg]) then return tostring(arg) end
    alreadyEncountered[arg] = true
    if arg == nil then return tostring(arg) end

    local str = "{" .. "'" .. tostring(arg) .. "'"
    for k, v in pairs(arg) do
        str = str .. k .. "=" .. utils.tostring(v, alreadyEncountered) .. ","
    end
    str = str .. "}"
    return str
end

function utils.dump(obj) print(utils.tostring(obj, {})) end

function utils.addAll(target, source)
    for k, v in pairs(source) do table.insert(target, v) end
end

function utils.genlines(xfrom, yfrom, xto, yto)
    if xto - xfrom < yto - yfrom then
        for i = yfrom, yto do print("tile(" .. xfrom .. "," .. i .. "),") end
    else
        for i = xfrom, xto do print("tile(" .. i .. "," .. yfrom .. "),") end
    end
end

function utils.prettyTime(seconds)
    local secondsLeft = seconds
    local minutes = 0
    if (seconds > 60) then
        minutes = math.floor(seconds / 60)
        secondsLeft = seconds - (60 * minutes)
    end
    return string.format("%02d:%02d", minutes, secondsLeft)
end


function utils.clamp(val, min, max)
    return math.max(min, math.min(val, max));
end


function utils.bxor( a, b )
    if hasbit then
        return bit.bxor(a,b)
    end

    --pure lua version so we can use it in love.js
    local p,c=1,0
    while a>0 and b>0 do
        local ra,rb=a%2,b%2
        if ra~=rb then c=c+p end
        a,b,p=(a-ra)/2,(b-rb)/2,p*2
    end
    if a<b then a=b end
    while a>0 do
        local ra=a%2
        if ra>0 then c=c+p end
        a,p=(a-ra)/2,p*2
    end
    return c
end